(($, Drupal, once) => {
  Drupal.behaviors.LbPlusToggleLayoutOutlines = {
    attach: (context, settings) => {
      once('LbPlusToggleLayoutOutlines', '#navigation-plus-toggle-layout-outline', context).forEach(toggle => {

        const enabled = localStorage.getItem('lb_plus.layout_outline');
        if (enabled === 'true') {
          toggle.checked = true;
        }

        Drupal.behaviors.LbPlusToggleLayoutOutlines.toggle(toggle);

        toggle.addEventListener('change', (e) => {
          Drupal.behaviors.LbPlusToggleLayoutOutlines.toggle(e.target);
          localStorage.setItem('lb_plus.layout_outline', e.target.checked);
        });
      });
    },
    toggle: (input) => {
      if (input.checked) {
        Drupal.behaviors.LbPlusToggleLayoutOutlines.outline();
      } else {
        Drupal.behaviors.LbPlusToggleLayoutOutlines.removeOutline();
      }
    },
    outline: () => {
      document.querySelectorAll('.layout__region').forEach(column => {
        if (!column.classList.contains('layout-outline')) {
          column.classList.add('layout-outline');
        }
      });
    },
    removeOutline: () => {
      document.querySelectorAll('.layout__region').forEach(column => {
        column.classList.remove('layout-outline');
      });
    },
  };

  Drupal.behaviors.LbPlusAjaxLayoutOutlines = {
    attach: (context, settings) => {
      once('LbPlusAjaxLayoutOutlines', '.layout__region', context).forEach(column => {
        const enabled = localStorage.getItem('lb_plus.layout_outline');
        if (enabled === 'true' && !column.classList.contains('layout-outline')) {
          column.classList.add('layout-outline');
        }
      });
    }
  };

})(jQuery, Drupal, once);
